## Xalan-C++ API Documentation

### The Xalan C++ XSLT Processor Version 1.6

Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members

# XercesAttrBridge Class Reference

`#include <XercesAttrBridge.hpp>`

Inheritance diagram for XercesAttrBridge

Collaboration diagram for XercesAttrBridge:

List of all members.

## Public Methods

- XercesAttrBridge ( const DOM_AttrType& theXercesAttr, const XercesBridgeNavigator& theNavigator)
- virtual ~XercesAttrBridge ()
- virtual const XalanDOMString& getNodeName () const
- virtual const XalanDOMString& getNodeValue () const
    Gets the value of this node, depending on its type.
- virtual NodeType getNodeType () const
    An enum value representing the type of the underlying object.
- virtual XalanNode* getParentNode () const
    Gets the parent of this node. More...
- virtual const XalanNodeList* getChildNodes () const
    Gets a `NodeList` that contains all children of this node. More...
- virtual XalanNode* getFirstChild () const
    Gets the first child of this node. More...
- virtual XalanNode* getLastChild () const
    Gets the last child of this node. More...
- virtual XalanNode* getPreviousSibling () const
    Gets the node immediately preceding this node. More...
- virtual XalanNode* getNextSibling () const
    Gets the node immediately following this node. More...
- virtual const XalanNamedNodeMap* getAttributes () const
    Gets a `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise.
- virtual XalanDocument* getOwnerDocument () const
    Gets the `DOM_Document` object associated with this node. More...
- DOM_AttrType getXercesNode () const
    Get the Xerces node this instance represent. More...

Cloning function.

- virtual XercesAttrBridge* cloneNode (bool deep) const
    Returns a duplicate of this node. More...

Functions to modify the DOM Node.

- virtual XalanNode* insertBefore ( XalanNode* newChild, XalanNode* refChild)
    Inserts the node `newChild` before the existing child node `refChild`. More...
- virtual XalanNode* replaceChild ( XalanNode* newChild, XalanNode* oldChild)
    Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node. More...
- virtual XalanNode* removeChild (XalanNode* oldChild)
    Removes the child node indicated by `oldChild` from the list of children, and returns it. More...
- virtual XalanNode* appendChild (XalanNode* newChild)
    Adds the node `newChild` to the end of the list of children of this node. More...

Query functions.

- virtual bool hasChildNodes () const
    This is a convenience method to allow easy determination of whether a node has any children. More...

Set functions.

- virtual void setNodeValue (const XalanDOMString& nodeValue)
    Sets the value of the node. More...

Functions introduced in DOM Level 2.

- virtual void normalize ()
    Puts all `DOM_Text` nodes in the full depth of the sub-tree underneath this `DOM_Node`, including attribute nodes, into a "normal" form where only markup (e.g., tags, comments, processing instructions, CDATA sections, and entity references) separates `DOM_Text` nodes, i.e., there are no adjacent `DOM_Text` nodes. More...
- virtual bool isSupported ( const XalanDOMString& feature, const XalanDOMString& version) const
    Tests whether the DOM implementation implements a specific feature and that feature is supported by this node. More...
- virtual const XalanDOMString& getNamespaceURI () const
    Get the namespace URI of this node, or `null` if it is unspecified. More...
- virtual const XalanDOMString& getPrefix () const
    Get the namespace prefix of this node, or `null` if it is unspecified.
- virtual const XalanDOMString& getLocalName () const
    Returns the local part of the qualified name of this node. More...
- virtual void setPrefix (const XalanDOMString& prefix)
    Set the namespace prefix of this node. More...
- virtual bool isIndexed () const
    Puts all `DOM_Text` nodes in the full depth of the sub-tree underneath this `DOM_Node`, including attribute nodes, into a "normal" form where only markup (e.g., tags, comments, processing instructions, CDATA sections, and entity references) separates `DOM_Text` nodes, i.e., there are no adjacent `DOM_Text` nodes. More...
- virtual IndexType getIndex () const
    Puts all `DOM_Text` nodes in the full depth of the sub-tree underneath this `DOM_Node`, including attribute nodes, into a "normal" form where only markup (e.g., tags, comments, processing instructions, CDATA sections, and entity references) separates `DOM_Text` nodes, i.e., there are no adjacent `DOM_Text` nodes. More...

Getter functions

- virtual const XalanDOMString& getName () const
    Returns the name of this attribute.
- virtual bool getSpecified () const
    Returns true if the attribute received its value explicitly in the XML document, or if a value was assigned programatically with the setValue function. More...
- virtual const XalanDOMString& getValue () const
    Returns the value of the attribute. More...

Setter functions

- virtual void setValue (const XalanDOMString& value)
    Sets the value of the attribute. More...

Functions introduced in DOM Level 2.

- virtual XalanElement* getOwnerElement () const
    The `Element` node this attribute is attached to or `null` if this attribute is not in use.

## Constructor & Destructor Documentation

XercesAttrBridge::XercesAttrBridge ( | const DOM_AttrType & theXercesAttr,
| const XercesBridgeNavigator & theNavigator )

virtual XercesAttrBridge::~XercesAttrBridge ( | )`[virtual]`

## Member Function Documentation

XalanNode * XercesAttrBridge::appendChild ( | XalanNode * newChild )`[virtual]`

Adds the node `newChild` to the end of the list of children of this node.

If the `newChild` is already in the tree, it is first removed.

Parameters:

  newChild | The node to add.If it is a `DocumentFragment` object, the entire contents of the document fragment are moved into the child list of this node

Returns:
  The node added.

Reimplemented from XalanAttr.

XercesAttrBridge * XercesAttrBridge::cloneNode ( | bool deep ) const`[virtual]`

Returns a duplicate of this node.

This function serves as a generic copy constructor for nodes.

The duplicate node has no parent ( `parentNode` returns `null`.).
Cloning an `Element` copies all attributes and their values, including those generated by the XML processor to represent defaulted attributes, but this method does not copy any text it contains unless it is a deep clone, since the text is contained in a child `Text` node. Cloning any other type of node simply returns a copy of this node.

Parameters:

  deep | If `true`, recursively clone the subtree under the specified node; if `false`, clone only the node itself (and its attributes, if it is an `Element`).

Returns:
  The duplicate node.

Reimplemented from XalanAttr.

const XalanNamedNodeMap * XercesAttrBridge::getAttributes ( | ) const`[virtual]`

Gets a `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise.

Reimplemented from XalanAttr.

const XalanNodeList * XercesAttrBridge::getChildNodes ( | ) const`[virtual]`

Gets a `NodeList` that contains all children of this node.

If there are no children, this is a `NodeList` containing no nodes. The content of the returned `NodeList` is "live" in the sense that, for instance, changes to the children of the node object that it was created from are immediately reflected in the nodes returned by the `NodeList` accessors; it is not a static snapshot of the content of the node. This is true for every `NodeList`, including the ones returned by the `getElementsByTagName` method.

Reimplemented from XalanAttr.

XalanNode * XercesAttrBridge::getFirstChild ( | ) const`[virtual]`

Gets the first child of this node.

If there is no such node, this returns `null`.

Reimplemented from XalanAttr.

IndexType XercesAttrBridge::getIndex ( | ) const`[virtual]`

Puts all `DOM_Text` nodes in the full depth of the sub-tree underneath this `DOM_Node`, including attribute nodes, into a "normal" form where only markup (e.g., tags, comments, processing instructions, CDATA sections, and entity references) separates `DOM_Text` nodes, i.e., there are no adjacent `DOM_Text` nodes.

This can be used to ensure that the DOM view of a document is the same as if it were saved and re-loaded, and is useful when operations (such as XPointer lookups) that depend on a particular document tree structure are to be used.

Note: In cases where the document contains `DOM_CDATASections`, the normalize operation alone may not be sufficient, since XPointers do not differentiate between `DOM_Text` nodes and `DOM_CDATASection` nodes.

Reimplemented from XalanAttr.

XalanNode * XercesAttrBridge::getLastChild ( | ) const`[virtual]`

Gets the last child of this node.

If there is no such node, this returns `null`.

Reimplemented from XalanAttr.

const XalanDOMString & XercesAttrBridge::getLocalName ( | ) const`[virtual]`

Returns the local part of the qualified name of this node.

For nodes created with a DOM Level 1 method, such as `createElement` from the `DOM_Document` interface, it is null.

Reimplemented from XalanAttr.

const XalanDOMString & XercesAttrBridge::getName ( | ) const`[virtual]`

Returns the name of this attribute.

Reimplemented from XalanAttr.

const XalanDOMString & XercesAttrBridge::getNamespaceURI ( | ) const`[virtual]`

Get the namespace URI of this node, or `null` if it is unspecified.

This is not a computed value that is the result of a namespace lookup based on an examination of the namespace declarations in scope. It is merely the namespace URI given at creation time.

For nodes of any type other than `ELEMENT_NODE` and `ATTRIBUTE_NODE` and nodes created with a DOM Level 1 method, such as `createElement` from the `Document` interface, this is always `null`.

Reimplemented from XalanAttr.

XalanNode * XercesAttrBridge::getNextSibling ( | ) const`[virtual]`

Gets the node immediately following this node.

If there is no such node, this returns `null`.

Reimplemented from XalanAttr.

virtual const XalanDOMString& XercesAttrBridge::getNodeName ( | ) const`[virtual]`

Reimplemented from XalanAttr.

NodeType XercesAttrBridge::getNodeType ( | ) const`[virtual]`

An enum value representing the type of the underlying object.

Reimplemented from XalanAttr.

const XalanDOMString & XercesAttrBridge::getNodeValue ( | ) const`[virtual]`

Gets the value of this node, depending on its type.

Reimplemented from XalanAttr.

XalanDocument * XercesAttrBridge::getOwnerDocument ( | ) const`[virtual]`

Gets the `DOM_Document` object associated with this node.

This is also the `DOM_Document` object used to create new nodes. When this node is a `DOM_Document` or a `DOM_DocumentType` which is not used with any `DOM_Document` yet, this is `null`.

Reimplemented from XalanAttr.

XalanElement * XercesAttrBridge::getOwnerElement ( | ) const`[virtual]`

The `Element` node this attribute is attached to or `null` if this attribute is not in use.

Reimplemented from XalanAttr.

XalanNode * XercesAttrBridge::getParentNode ( | ) const`[virtual]`

Gets the parent of this node.

All nodes, except `Document`, `DocumentFragment`, and `Attr` may have a parent. However, if a node has just been created and not yet added to the tree, or if it has been removed from the tree, a `null` DOM_Node is returned.

Reimplemented from XalanAttr.

const XalanDOMString & XercesAttrBridge::getPrefix ( | ) const`[virtual]`

Get the namespace prefix of this node, or `null` if it is unspecified.

Reimplemented from XalanAttr.

XalanNode * XercesAttrBridge::getPreviousSibling ( | ) const`[virtual]`

Gets the node immediately preceding this node.

If there is no such node, this returns `null`.

Reimplemented from XalanAttr.

bool XercesAttrBridge::getSpecified ( | ) const`[virtual]`

Returns true if the attribute received its value explicitly in the XML document, or if a value was assigned programatically with the setValue function.

Returns false if the attribute value came from the default value declared in the document's DTD.

Reimplemented from XalanAttr.

const XalanDOMString & XercesAttrBridge::getValue ( | ) const`[virtual]`

Returns the value of the attribute.

The value of the attribute is returned as a string. Character and general entity references are replaced with their values.

Reimplemented from XalanAttr.

DOM_AttrType XercesAttrBridge::getXercesNode ( | ) const`[]`

Get the Xerces node this instance represent.

Returns:
  The Xerces node

bool XercesAttrBridge::hasChildNodes ( | ) const`[virtual]`

This is a convenience method to allow easy determination of whether a node has any children.

Returns:
  `true` if the node has any children, `false` if the node has no children.

Reimplemented from XalanAttr.

XalanNode * XercesAttrBridge::insertBefore ( | XalanNode * newChild,
| XalanNode * refChild )`[virtual]`

Inserts the node `newChild` before the existing child node `refChild`.

If `refChild` is `null`, insert `newChild` at the end of the list of children.
If `newChild` is a `DocumentFragment` object, all of its children are inserted, in the same order, before `refChild`. If the `newChild` is already in the tree, it is first removed. Note that a `DOM_Node` that has never been assigned to refer to an actual node is == null.

Parameters:

  newChild | The node to insert.
  refChild | The reference node, i.e., the node before which the new node must be inserted.

Returns:
  The node being inserted.

Reimplemented from XalanAttr.

bool XercesAttrBridge::isIndexed ( | ) const`[virtual]`

Puts all `DOM_Text` nodes in the full depth of the sub-tree underneath this `DOM_Node`, including attribute nodes, into a "normal" form where only markup (e.g., tags, comments, processing instructions, CDATA sections, and entity references) separates `DOM_Text` nodes, i.e., there are no adjacent `DOM_Text` nodes.

This can be used to ensure that the DOM view of a document is the same as if it were saved and re-loaded, and is useful when operations (such as XPointer lookups) that depend on a particular document tree structure are to be used.

Note: In cases where the document contains `DOM_CDATASections`, the normalize operation alone may not be sufficient, since XPointers do not differentiate between `DOM_Text` nodes and `DOM_CDATASection` nodes.

Reimplemented from XalanAttr.

bool XercesAttrBridge::isSupported ( | const XalanDOMString & feature,
| const XalanDOMString & version ) const`[virtual]`

Tests whether the DOM implementation implements a specific feature and that feature is supported by this node.

Parameters:

  feature | The string of the feature to test. This is the same name as what can be passed to the method `hasFeature` on `DOMImplementation`.
  version | This is the version number of the feature to test. In Level 2, version 1, this is the string "2.0". If the version is not specified, supporting any version of the feature will cause the method to return `true`.

Returns:
  Returns `true` if the specified feature is supported on this node, `false` otherwise.

Reimplemented from XalanAttr.

void XercesAttrBridge::normalize ( | )`[virtual]`

Puts all `DOM_Text` nodes in the full depth of the sub-tree underneath this `DOM_Node`, including attribute nodes, into a "normal" form where only markup (e.g., tags, comments, processing instructions, CDATA sections, and entity references) separates `DOM_Text` nodes, i.e., there are no adjacent `DOM_Text` nodes.

This can be used to ensure that the DOM view of a document is the same as if it were saved and re-loaded, and is useful when operations (such as XPointer lookups) that depend on a particular document tree structure are to be used.

Note: In cases where the document contains `DOM_CDATASections`, the normalize operation alone may not be sufficient, since XPointers do not differentiate between `DOM_Text` nodes and `DOM_CDATASection` nodes.

Reimplemented from XalanAttr.

XalanNode * XercesAttrBridge::removeChild ( | XalanNode * oldChild )`[virtual]`

Removes the child node indicated by `oldChild` from the list of children, and returns it.

Parameters:

  oldChild | The node being removed.

Returns:
  The node removed.

Reimplemented from XalanAttr.

XalanNode * XercesAttrBridge::replaceChild ( | XalanNode * newChild,
| XalanNode * oldChild )`[virtual]`

Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node.

If `newChild` is a `DOM_DocumentFragment` object, `oldChild` is replaced by all of the `DOM_DocumentFragment` children, which are inserted in the same order.

If the `newChild` is already in the tree, it is first removed.

Parameters:

  newChild | The new node to put in the child list.
  oldChild | The node being replaced in the list.

Returns:
  The node replaced.

Reimplemented from XalanAttr.

void XercesAttrBridge::setNodeValue ( | const XalanDOMString & nodeValue )`[virtual]`

Sets the value of the node.

Any node which can have a nodeValue (

See also:
  getNodeValue()) will also accept requests to set it to a string. The exact response to this varies from node to node -- Attribute, for example, stores its values in its children and has to replace them with a new Text holding the replacement value.

For most types of Node, value is null and attempting to set it will throw DOMException(NO_MODIFICATION_ALLOWED_ERR). This will also be thrown if the node is read-only.

Reimplemented from XalanAttr.

void XercesAttrBridge::setPrefix ( | const XalanDOMString & prefix )`[virtual]`

Set the namespace prefix of this node.

Note that setting this attribute, when permitted, changes the `nodeName` attribute, which holds the qualified name, as well as the `tagName` and `name` attributes of the `DOM_Element` and `DOM_Attr` interfaces, when applicable.

Note also that changing the prefix of an attribute, that is known to have a default value, does not make a new attribute with the default value and the original prefix appear, since the `namespaceURI` and `localName` do not change.

Parameters:

  prefix | The prefix of this node.

Exceptions:

  DOMException

  INVALID_CHARACTER_ERR: Raised if the specified prefix contains an illegal character.
  NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
  NAMESPACE_ERR: Raised if the specified `prefix` is malformed, if the specified prefix is "xml" and the `namespaceURI` of this node is different from "http://www.w3.org/XML/1998/namespace", if specified prefix is "xmlns" and the `namespaceURI` is neither `null` nor an empty string, or if the `localName` is `null`.

Reimplemented from XalanAttr.

void XercesAttrBridge::setValue ( | const XalanDOMString & value )`[virtual]`

Sets the value of the attribute.

A text node with the unparsed contents of the string will be created.

Parameters:

  value | The value of the DOM attribute to be set

Reimplemented from XalanAttr.

The documentation for this class was generated from the following file:

- XercesAttrBridge.hpp

Interpreting class diagrams

Doxygen and GraphViz are used to generate this API documentation from the Xalan-C header files.

Xalan-C++ XSLT Processor Version 1.6 Copyright © 2000, 2001, 2002, 2003 The Apache Software Foundation. All Rights Reserved.